#include "StdAfx.h"
#include "UpdaterView.h"
#include "Resource.h"
#include "Application.h"
#include "UpdaterModel.h"
#include "TrayIconHandler.h"
#include "SimpleImageShape.h"
#include <NButton.h>
#include <TipCommand.h>
#include "UpdaterModel.h"
#include "UpdaterNavigator.h"


extern HMODULE _hModule;
namespace tipupdater
{

UpdaterView::UpdaterView(void):TipView(_T("tip_updater_main")/*_T("tip_pad_main")*/),m_bInitSilent(TRUE)
{
	m_WindowPos.x = 0xffffffff;
	m_WindowPos.y = 0xffffffff;
	m_singletonDialog = NULL;
}

UpdaterView::~UpdaterView(void)
{

}

void UpdaterView::RecalcLayout()
{
	CComponent* content = this->FindName(_T("content"));
	if (content)
	{
		content->RecalcLayout(TRUE);
		content->Invalidate();
	}
}
void UpdaterView::Init()
{
//	if (m_bInitSilent == FALSE)
//	{
//		__super::Init();
//	}
	//	m_bInitSilent = FALSE;

	//TrayIconHandler::CreateInstacne()->TryShow();
	SetIcon();	
}
void UpdaterView::SetIcon()
{
	HICON hIcon = LoadIcon(_hModule, MAKEINTRESOURCE(IDI_TIPUPDATER));
	HICON hSmallIcon = LoadIcon(_hModule, MAKEINTRESOURCE(IDI_SMALL));
	CRootWindow* rootWindow = GetMainWindow();
	if ( rootWindow != NULL)
	{
		HWND hWndMain = rootWindow->GetWindow();
		if (::IsWindow(hWndMain))
		{
			SendMessage(GetMainWindow()->GetWindow(), WM_SETICON, ICON_BIG, (LPARAM)hIcon);
			SendMessage(GetMainWindow()->GetWindow(), WM_SETICON, ICON_SMALL, (LPARAM)hSmallIcon);
		}
	}
}

HWND UpdaterView::GetActiveWindow(BOOL bMainWindow)
{
	CRootWindow* rootWindow = GetMainWindow();
	if (rootWindow)
	{
		CRootContainer* rootContainer = rootWindow->GetRootContainer();
		if (rootContainer)
		{
			if (rootContainer->IsVisible())
			{
				HWND hMainView = rootWindow->GetWindow();
				HWND hPopupWnd = GetLastActivePopup(hMainView);
				HWND hOwner = GetWindow(hPopupWnd, GW_OWNER);
				// ˾ 찡  ̸ ˾ Ѵ.
				if (hOwner == hMainView && bMainWindow == FALSE) 
					return hPopupWnd;
				else
					return hMainView;
			}
		}
	}
	return GetDesktopWindow();
}

void UpdaterView::CloseMainWindow()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return;

	CRootContainer* rootContainer = rootWindow->GetRootContainer();
	if (!rootContainer)
		return;

	HWND hWnd = rootWindow->GetWindow();
	if (!hWnd)
		return;

	RECT rect;
	GetWindowRect(hWnd, &rect);
	m_WindowPos.x = rect.left;
	m_WindowPos.y = rect.top;

	RECT rcVirtualArea;
	rcVirtualArea.left = rcVirtualArea.top = 0;
	rcVirtualArea.right  = ::GetSystemMetrics( SM_CXVIRTUALSCREEN );
	rcVirtualArea.bottom  = ::GetSystemMetrics( SM_CYVIRTUALSCREEN );
	//   ġ ʱȭ 
	if (rect.left < rcVirtualArea.left || rect.top < rcVirtualArea.top
		|| rcVirtualArea.right < rect.left || rcVirtualArea.bottom < rcVirtualArea.top)
	{
		m_WindowPos.x = 0xffffffff;
		m_WindowPos.y = 0xffffffff;
	}


	::DestroyWindow(hWnd);
//	rootContainer->Destroy();
	this->SetMainWindow(NULL);

	Application* application = Application::get_instance();
	UpdaterModel* updaterModel = dynamic_cast<UpdaterModel*>(application->GetModel());
	UpdaterDocument* document = updaterModel->GetDocument();

	//TrayIconHandler::CreateInstacne()->TryHide();

}
BOOL UpdaterView::OpenMainWindow()
{
	BOOL bCreateMainWindow = FALSE;
	CRootWindow* rootWindow = GetMainWindow();
	if (rootWindow)
	{
		HWND hWnd = rootWindow->GetWindow();
		ShowWindow(hWnd, SW_SHOWNORMAL);
		SetForegroundWindow(GetActiveWindow());
	}
	else
	{
		// ġ/Ʈ ߿  並 ٽ   ʵ Ѵ.
		Application* application = Application::get_instance();
		UpdaterModel* updaterModel = dynamic_cast<UpdaterModel*>(application->GetModel());
		UpdaterDocument* document = updaterModel->GetDocument();
		if (NULL == document->GetPendingService())
		{
			this->Init();
		}
		bCreateMainWindow = TRUE;
		rootWindow = GetMainWindow();
		if (rootWindow)
		{
			if (m_WindowPos.x != 0xffffffff && m_WindowPos.y != 0xffffffff)
			{
				SetWindowPos(rootWindow->GetWindow(), NULL, m_WindowPos.x, m_WindowPos.y, -1, -1,
					SWP_NOSIZE | SWP_NOZORDER | SWP_NOACTIVATE);
			}
		}
	}	

	//TrayIconHandler::CreateInstacne()->TryShow();
	return bCreateMainWindow;
}

BOOL UpdaterView::IsVisibleMainWindow()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return FALSE;

	CRootContainer* rootConatiner = rootWindow->GetRootContainer();
	if (!rootConatiner)
		return FALSE;

	HWND hWnd = rootWindow->GetWindow();
	if (!hWnd)
		return FALSE;

	return rootConatiner->IsVisible();
}
void UpdaterView::Invalidate()
{
	CRootWindow* rootWindow = GetMainWindow();
	if (!rootWindow)
		return;

	CRootContainer* rootConatiner = rootWindow->GetRootContainer();
	if (!rootConatiner)
		return;

	rootConatiner->Invalidate();
}

};